include \masm32\include\masm32rt.inc

.data?
hFile	dd ?
fSize	dd ?
pMem	dd ?
MbRetAddr	dd ?
BigFatBuffer	dd 10000h dup(?)

.code
start:
	mov hFile, fopen("MyText.txt")			; we open a textfile
	.if eax==INVALID_HANDLE_VALUE
		MsgBox 0, LastError$(), "No such file:", MB_OK
	.else
		mov fSize, fsize(hFile)		; allocate a buffer for reading in the file
		.if eax!=4095 && eax!=4096		; we are testing the bounds
			MsgBox 0, "Check your file size", "Hi", MB_OK
		.endif
		invoke VirtualAlloc, NULL, fSize, MEM_COMMIT, PAGE_READWRITE
		.if eax==0
			MsgBox 0, LastError$(), "VirtualAlloc failure:", MB_OK
		.else
			mov pMem, eax		; we keep a pointer to the buffer
			.if fread(hFile, pMem, fSize)!=fSize
				MsgBox 0, LastError$(), "There was an error reading the file:", MB_OK
			.endif
			fclose hFile	
			print "The file size is "	; you will see this message
			print str$(fSize), " bytes", 13, 10
			invoke lstrcpy, offset BigFatBuffer, chr$("Here is the content:", 13, 10)

			; all fine until we are trying to append the contents of our file - see below for details:
			invoke lstrcat, offset BigFatBuffer, pMem

			print offset BigFatBuffer	; you should see the content now

			print chr$(13,10,13,10, "---- OK ----", 13, 10)
			invoke VirtualFree, pMem, 0, MEM_RELEASE
		.endif
	.endif
	getkey
	exit
end start

CPU Disasm
Address                  Hex dump                   Command
7C834D56                  8A08                      mov cl, byte ptr [eax]
7C834D58                  40                        inc eax
7C834D59                  84C9                      test cl, cl
7C834D5B                 75 F9                     jne short kernel32.7C834D56
; ------- try setting a breakpoint after the jne -------------
7C834D5D                  2BC2                      sub eax, edx

; ------- you will see this one only if you animate for some minutes -------
; ntdll.KiUserExceptionDispatcher(pExceptionRecord,pContext)
KiUserExceptionDispatche  8B4C24 04                 mov ecx, dword ptr [esp+4]
7C90EAF0                  8B1C24                    mov ebx, dword ptr [esp]
Access violation in KERNEL32 ignored on request - passed to application


OPT_Tmp2Asm	1
